Skip to content

Cacheability query Query.

POST
/api/data/namespaces/{namespace}/graph/lb_cache_content
curl --request POST \
--url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/data/namespaces/example/graph/lb_cache_content \
--header 'Authorization: <Authorization>' \
--header 'Content-Type: application/json' \
--data '{ "end_time": "example", "field_selector": [ "METRIC_TYPE_NONE" ], "group_by": [ "NONE" ], "label_filter": [ { "label": "LABEL_NONE", "op": "NOP", "value": "example" } ], "namespace": "example", "start_time": "example", "step": "example" }'

Request to GET time-series cacheable data for HTTP-LBs.

Examples of this operation.

namespace
required
string

Namespace namespace is used to scope load balancers. Only LB’s in given namespace will be considered.

Media typeapplication/json
Cacheable Content Request

Graph/cacheable_content API is used to GET data for CDN services.

object
end_time
End time

End time of metric collection from which data will be considered to build graph. Format: unix_timestamp|RFC 3339

Optional: If not specified, then the end_time will be evaluated to start_time+10m If start_time is not specified, then the end_time will be evaluated to

string
<= 1024 characters
field_selector
Field Selector

Select fields to be returned in the response. Optional: If not specified, only the following fields are returned in the response. REQUEST_RATE, RESPONSE_THROUGHPUT.

Array<string>
Allowed values: METRIC_TYPE_NONE REQUEST_RATE ERROR_RATE RESPONSE_LATENCY REQUEST_THROUGHPUT RESPONSE_THROUGHPUT ERROR_RATE_3XX ERROR_RATE_4XX ERROR_RATE_5XX RESPONSE_LATENCY_PERCENTILE_50 RESPONSE_LATENCY_PERCENTILE_90 RESPONSE_LATENCY_PERCENTILE_99 RESPONSE_DATA_TRANSFER_DURATION CLIENT_RTT SERVER_RTT SERVER_DATA_TRANSFER_TIME APP_LATENCY REQUEST_TO_ORIGIN_RATE HTTP_REQUEST_RATE HTTP_ERROR_RATE HTTP_ERROR_RATE_4XX HTTP_ERROR_RATE_5XX HTTP_RESPONSE_LATENCY HTTP_RESPONSE_LATENCY_PERCENTILE_50 HTTP_RESPONSE_LATENCY_PERCENTILE_90 HTTP_RESPONSE_LATENCY_PERCENTILE_99 HTTP_SERVER_DATA_TRANSFER_TIME HTTP_APP_LATENCY TCP_CONNECTION_RATE TCP_ERROR_RATE TCP_ERROR_RATE_CLIENT TCP_ERROR_RATE_UPSTREAM TCP_CONNECTION_DURATION RESPONSE_RATE ACTIVE_CONNECTIONS NEW_CONNECTION_RATE HTTP_INGRESS_REQUEST_RATE HTTP_EGRESS_REQUEST_RATE
group_by
Group by

Aggregate data by any or all of namespace, cacheability, vhost.

Optional: If not specified, then the data is aggregated/grouped by vh_name.

Array<string>
<= 4 items
Allowed values: NONE NAMESPACE SITE APP_TYPE SERVICE VHOST VIRTUAL_HOST_TYPE VIP CACHEABILITY NODE
label_filter
Label Filter

List of label filter expressions of the form “label key” QueryOp “value”. Response will only contain data that matches all the conditions specified in the label_filter. For cacheable content, user should specify LABEL_VHOST_CACHE & LABEL_VHOST in the label_filter

Required: YES.

Array<object>
>= 1 items <= 16 items
Label Filter

Metrics used to render the service graph are tagged with labels listed in the enum Label. Label Filter is used to filter the timeseries that match the specified label key/value and the operator.

object
label
string
default: LABEL_NONE
Allowed values: LABEL_NONE LABEL_SITE LABEL_APP_TYPE LABEL_SERVICE LABEL_VHOST_TYPE LABEL_VHOST LABEL_VIP LABEL_VHOST_CACHE LABEL_NODE
op
string
default: NOP
Allowed values: NOP EQ NEQ
value
Value

Value of the label.

string
>= 3 characters <= 1024 characters
namespace
Namespace

Namespace is used to scope load balancers. Only LB’s in given namespace will be considered.

string
>= 6 characters <= 1024 characters
start_time
Start time

Start time of metric collection from which data will be considered to build graph. Format: unix_timestamp|RFC 3339

Optional: If not specified, then the start_time will be evaluated to end_time-10m If end_time is not specified, then the start_time will be evaluated to -10m.

string
<= 1024 characters
step
Step

Step is the resolution width, which determines the number of the data points [x-axis (time)] to be returned in the response. The timestamps in the response will be t1=start_time, t2=t1+step, … Tn=tn-1+step, where tn <= end_time. Format: [0-9][smhd], where s - seconds, m - minutes, h - hours, d - days

Optional: If not specified, then step size is evaluated to <end_time - start_time>

string
<= 1024 characters

A successful response.

Media typeapplication/json
Cacheable Content Response

Response for graph/cacheable_content request contains a list of nodes.

object
nodes
Nodes

List of LB’s in requested for Cacheable Content Data.

Array<object>
Cacheable Content Data

Cacheable Content Data wraps all the response data for a load balancer.

object
id
object
app_type
App Type

Identifies the application type associated with the virtual host.

string
<= 1024 characters
cacheability
CACHEABILITY

Identifies the Cacheability associated with the Virtual Host.

string
<= 1024 characters
namespace
Namespace

Identifies the workspace where the service is deployed.

string
>= 6 characters <= 1024 characters
service
Service

Identifies the source or destination service.

string
<= 1024 characters
site
Site

Identifies the source or destination site.

string
<= 1024 characters
vhost
Virtual Host

Identifies the virtual host.

string
<= 1024 characters
vip
VIP

Identifies the VIP associated with the Virtual Host.

string
<= 1024 characters
virtual_host_type
Virtual Host Type

Identifies the Virtual host type.

string
<= 1024 characters
node
NODE

Identifies a node.

string
<= 1024 characters
metric
Metric

List of metric specified in the request for a load balancer.

Array<object>
CDN Metric Data

CdnMetricData contains the metric type and the corresponding metric value(s)

object
type
string
default: METRIC_TYPE_NONE
Allowed values: METRIC_TYPE_NONE REQUEST_RATE ERROR_RATE RESPONSE_LATENCY REQUEST_THROUGHPUT RESPONSE_THROUGHPUT ERROR_RATE_3XX ERROR_RATE_4XX ERROR_RATE_5XX RESPONSE_LATENCY_PERCENTILE_50 RESPONSE_LATENCY_PERCENTILE_90 RESPONSE_LATENCY_PERCENTILE_99 RESPONSE_DATA_TRANSFER_DURATION CLIENT_RTT SERVER_RTT SERVER_DATA_TRANSFER_TIME APP_LATENCY REQUEST_TO_ORIGIN_RATE HTTP_REQUEST_RATE HTTP_ERROR_RATE HTTP_ERROR_RATE_4XX HTTP_ERROR_RATE_5XX HTTP_RESPONSE_LATENCY HTTP_RESPONSE_LATENCY_PERCENTILE_50 HTTP_RESPONSE_LATENCY_PERCENTILE_90 HTTP_RESPONSE_LATENCY_PERCENTILE_99 HTTP_SERVER_DATA_TRANSFER_TIME HTTP_APP_LATENCY TCP_CONNECTION_RATE TCP_ERROR_RATE TCP_ERROR_RATE_CLIENT TCP_ERROR_RATE_UPSTREAM TCP_CONNECTION_DURATION RESPONSE_RATE ACTIVE_CONNECTIONS NEW_CONNECTION_RATE HTTP_INGRESS_REQUEST_RATE HTTP_EGRESS_REQUEST_RATE
unit
string
default: UNIT_MILLISECONDS
Allowed values: UNIT_MILLISECONDS UNIT_SECONDS UNIT_MINUTES UNIT_HOURS UNIT_DAYS UNIT_BYTES UNIT_KBYTES UNIT_MBYTES UNIT_GBYTES UNIT_TBYTES UNIT_KIBIBYTES UNIT_MIBIBYTES UNIT_GIBIBYTES UNIT_TEBIBYTES UNIT_BITS_PER_SECOND UNIT_BYTES_PER_SECOND UNIT_KBITS_PER_SECOND UNIT_KBYTES_PER_SECOND UNIT_MBITS_PER_SECOND UNIT_MBYTES_PER_SECOND UNIT_CONNECTIONS_PER_SECOND UNIT_ERRORS_PER_SECOND UNIT_PACKETS_PER_SECOND UNIT_REQUESTS_PER_SECOND UNIT_PACKETS UNIT_PERCENTAGE UNIT_COUNT
value
Value

Cacheability value.

Array<object>
>= 3 characters <= 15 characters
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
step
step

Actual step size used in the response. It could be higher than the requested step due to metric rollups and the query duration. Format: [0-9][smhd], where s - seconds, m - minutes, h - hours, d - days.

string
<= 1024 characters
Example
{
"nodes": [
{
"metric": [
{
"type": "METRIC_TYPE_NONE",
"unit": "UNIT_MILLISECONDS",
"value": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
]
}
]
}
]
}

Returned when operation is not authorized.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when there is no permission to access resource.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when resource is not found.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation on resource is conflicting with current value.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation has been rejected as it is happening too frequently.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server encountered an error in processing API.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when service is unavailable temporarily.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server timed out processing request.

Media typeapplication/json
string format: string
Examplegenerated
example